【Leetcode】278. First Bad Version【二分查找】

278. First Bad Version

  • Total Accepted: 58296
  • Total Submissions: 248778
  • Difficulty: Easy

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.

Credits:
Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

Subscribe to see which companies asked this question


思路:二分

1、注意返回条件begin 和 end相等,和一开始调用findRange的条件。

2、这个是找第一个坏版本,所以递归调用的时候isBadVersion(mid)为1时,调用findRange(begin,mid),即不把mid排除,保留0和1的交汇点。

3、mid = (low+high)先发生了数据溢出,应该将其改为mid = low+(high-low)/2      //不知道这么解释对不对。


代码:

public class Solution extends VersionControl {
    public int firstBadVersion(int n) {
        if(n == 1||n == 0) return n;
        int res = findRange(1,n);
        return res;
    }
    
    public int findRange(int begin,int end){
        if(begin == end) return begin;
        
        int mid = begin + (end - begin)/2;
        boolean checkRes = isBadVersion(mid);

        if(checkRes)  
          return findRange(begin,mid);
        else 
          return findRange(mid+1,end);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值